<?php

namespace AMZcockpitDoctrine\Repository\MWS;

use AMZcockpitDoctrine\Entity\MWS\PanStocks;
use AMZcockpitDoctrine\Entity\MWS\Product;
use AMZcockpitDoctrine\Entity\MWS\Store;
use AMZcockpitDoctrine\Entity\User;
use Doctrine\ORM\QueryBuilder;

/**
 * ProductRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ProductRepository extends \Doctrine\ORM\EntityRepository
{
    public function getRelatedProduct(Product $product) {
        if($product->getParentProduct()) {
            $qb = $this->createQueryBuilder('p');
            $qb->select('p')
               ->where($qb->expr()->eq('p.parentProduct',':parentProduct'))
               ->setParameter('parentProduct',$product->getParentProduct());
            return $qb->getQuery()->getResult();
        }
        return null;
    }

    public function getAllProductsCount() {
        $qb = $this->createQueryBuilder('p');
        $qb->select('COUNT(p)');
        return $qb->getQuery()->getSingleScalarResult();
    }

    public function getProductsReviewsAverageByMarketPlace(User $user, $marketPlace = null, $filters = null) {

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('p.reviews','r');
        $qb->select('p.id, AVG(r.rating) AS averageRating, r.marketplaceId')
            ->where($qb->expr()->eq('s.user',':user'))
            ->andWhere($qb->expr()->eq('p.alertReviews',':alertReviews'))
            ->andWhere($qb->expr()->isNotNull('r.id'))
            ->setParameter('user',$user)
            ->setParameter('alertReviews',true)
            ->groupBy('p.id')
            ->addGroupBy('r.marketplaceId');

        /** @var QueryBuilder $qb */
        if($filters) {
            if(!empty($filters)) {
                if(!empty($filters['search'])) {
                    $qb->leftJoin('p.productInfos','pi');
                    $qb->andWhere(
                        $qb->expr()->orX(
                            $qb->expr()->orX(
                                $qb->expr()->like('p.ASIN',':search'),
                                $qb->expr()->like('p.name',':search')
                            ),
                           $qb->expr()->like('pi.title',':search')

                        )
                    )
                    ->setParameter('search', "%".$filters['search']."%");
                }
            }
        }

        $items = $qb->getQuery()->getResult();
        if(!$items) return null;

        $products = [];
        foreach ($items as $item) {
            $qb = $this->createQueryBuilder('p');
            $qb->select('p')->where($qb->expr()->eq('p.id',':id'))->setParameter('id',$item['id']);
            $product = $qb->getQuery()->getOneOrNullResult();

            $products[$item['id']]['marketplaces'][$item['marketplaceId']] = $item['averageRating'];
            if(!isset($products[$item['id']]['product']))
                $products[$item['id']]['product']   = $product;
        }
        return $products;
    }


    public function getActiveProductsByUser(User $user, $offset = null, $limit = null) {

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('s.user','u');
        $qb->select('p')
            ->where($qb->expr()->eq('s.user',':user'))
            ->setParameter('user',$user)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->andWhere($qb->expr()->eq('p.alertReviews',':alertReviews'))
            ->andWhere($qb->expr()->gte('p.inStockSupplyQuantity',':inStockSupplyQuantity'))
            ->setParameter('blocked',false)
            ->setParameter('alertReviews',true)
            ->setParameter('inStockSupplyQuantity',5)
        ;

        if($limit) {
            $qb->setFirstResult($offset);
            $qb->setMaxResults($limit);
        }
        $qb->orderBy('p.createdAt','DESC');

        return $qb->getQuery()->getResult();
    }

    public function getAllActiveProductsCount() {

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('s.user','u');
        $qb->select('COUNT(p)')
            ->andWhere($qb->expr()->eq('p.processReviews',':processReviews'))
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->andWhere($qb->expr()->eq('p.alertReviews',':alertReviews'))
            ->andWhere($qb->expr()->gte('p.inStockSupplyQuantity',':inStockSupplyQuantity'))
            ->setParameter('blocked',false)
            ->setParameter('alertReviews',true)
            ->setParameter('processReviews',false)
            ->setParameter('inStockSupplyQuantity',5);


        return $qb->getQuery()->getSingleScalarResult();
    }


    public function getActiveProcessingReviewsCount() {

        $qb = $this->createQueryBuilder('p');
        $qb->select('COUNT(p)')
            ->andWhere($qb->expr()->eq('p.processReviews',':processReviews'))
            ->setParameter('processReviews',true);

        return $qb->getQuery()->getSingleScalarResult();
    }


    public function getActiveProductsToFetch($offset = 0, $limit = 1) {

        $dateLastExec = new \DateTime('now');
        $dateLastExec->sub(new \DateInterval('PT24H'));

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('s.user','u');
        $qb->select('p')
            ->andWhere($qb->expr()->eq('p.processReviews',':processReviews'))
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->andWhere($qb->expr()->eq('p.alertReviews',':alertReviews'))
            ->andWhere($qb->expr()->gte('p.inStockSupplyQuantity',':inStockSupplyQuantity'))
            ->setParameter('blocked',false)
            ->setParameter('alertReviews',true)
            ->setParameter('processReviews',false)
            ->setParameter('inStockSupplyQuantity',5);

        $qb->andWhere(
            $qb->expr()->orX(
                $qb->expr()->lt('p.lastProcessReviewsExecutionDate',':lastProcessReviewsExecutionDate'),
                $qb->expr()->isNull('p.lastProcessReviewsExecutionDate')
            )
        )
            ->setParameter('lastProcessReviewsExecutionDate',$dateLastExec);

        $qb->orderBy('p.lastProcessReviewsExecutionDate','ASC');
        $qb->setFirstResult($offset);
        $qb->setMaxResults($limit);

        return $limit == 1 ? $qb->getQuery()->getOneOrNullResult() : $qb->getQuery()->getResult();
    }

    public function getProductByUser(User $user, $offset = null, $limit = null) {

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s');
        $qb->select('p')
            ->where($qb->expr()->eq('s.user',':user'))
            ->setParameter('user',$user);

        if($limit) {
            $qb->setFirstResult($offset);
            $qb->setMaxResults($limit);
        }
        $qb->orderBy('p.createdAt','DESC');

        return $qb->getQuery()->getResult();
    }


    public function getProductByUserToEmailsVariables(User $user) {

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('p.emailsProductVariables','epv')
            ->leftJoin('epv.emailVariable','ev');
        $qb->select('p')
            ->where($qb->expr()->eq('ev.user',':user'))
            ->andWhere($qb->expr()->eq('s.user',':user'))
            ->andWhere($qb->expr()->neq('p','epv.product'))
            ->setParameter('user',$user);

        return $qb->getQuery()->getResult();
    }

    public function getActiveProducts($offset = 0, $limit = 100) {

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('s.user','u');
        $qb->select('p')
            ->where($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false);

        $qb->setMaxResults($limit);
        $qb->setFirstResult($offset);
        return $qb->getQuery()->getResult();
    }

    public function getActiveProductsASINs() {
        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('p.productInfos','pi')
            ->leftJoin('s.user','u');
        $qb->select('p.ASIN')
            ->addSelect('GROUP_CONCAT(DISTINCT pi.marketplaceId) as marketplacesIds')
            ->where($qb->expr()->gte('p.inStockSupplyQuantity',':inStockSupplyQuantity'))
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->andWhere($qb->expr()->eq('u.enabled',':enabled'))
            ->andWhere($qb->expr()->eq('p.alertReviews',':alertReviews'))
            ->setParameter('blocked',false)
            ->setParameter('enabled',true)
            ->setParameter('alertReviews',true)
            ->setParameter('inStockSupplyQuantity',3)
            ->groupBy('p.ASIN');

        return $qb->getQuery()->getResult();
    }

    public function getActiveProductsASINs2() {

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('p.productInfos','pi')
            ->leftJoin('s.user','u')
            ->leftJoin('p.reviews','r');
        $qb->select('u.email, p.ASIN, p.inStockSupplyQuantity')
            ->where($qb->expr()->gte('p.inStockSupplyQuantity',':inStockSupplyQuantity'))
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->andWhere($qb->expr()->eq('p.alertReviews',':alertReviews'))
//            ->andWhere($qb->expr()->eq('p.status',':status'))
            ->setParameter('blocked',false)
            ->setParameter('alertReviews',true)
            ->setParameter('inStockSupplyQuantity',3)
//            ->setParameter('status',"Active")
            ->groupBy('p.ASIN')
            ->orderBy('u.email', 'DESC');

//        $qb->leftJoin('p.ordersItem' , 'i');
//        $qb->leftJoin('i.order' , 'o');
//        $qb->andWhere($qb->expr()->gte('o.purchaseDate', ':date'))->setParameter('date',$date);
        return $qb->getQuery()->getResult();
    }

    public function getActiveProductsByStore(Store $store,$offset = 0, $limit = 100) {

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('s.user','u');
        $qb->select('p')
            ->where($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false);
        $qb->andWhere($qb->expr()->eq('p.store',':store'))
            ->setParameter('store',$store);
        $qb->andWhere($qb->expr()->gt('p.inStockSupplyQuantity',':inStockSupplyQuantity'))
            ->setParameter('inStockSupplyQuantity',0);
        $qb ->andWhere($qb->expr()->eq('p.alertReviews',':alertReviews'))
            ->setParameter('alertReviews',true);

        $qb->setMaxResults($limit);
        $qb->setFirstResult($offset);
        return $qb->getQuery()->getResult();
    }

    public function getBuyedProductsForLastDay() {

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.ordersItem','oi')
            ->leftJoin('oi.order','o');
        $qb->select('p')
            ->distinct(true)
            ->andWhere(
                $qb->expr()->gte('o.purchaseDate',':dateMax')
            )->setParameter('dateMax',(new \DateTime('today'))->format('Y-m-d H:i:s'));

        return $qb->getQuery()->getResult();
    }

    public function getASINsByStore(Store $store) {

        $qb = $this->createQueryBuilder('p');
        $qb->select('p.ASIN')
            ->leftJoin('p.productInfos','pi')
            ->addSelect('GROUP_CONCAT(DISTINCT pi.marketplaceId) as marketplacesIds')
            ->groupBy('p.ASIN');
        $qb->andWhere($qb->expr()->eq('p.store',':store'))
            ->setParameter('store',$store);

        $items = $qb->getQuery()->getResult();
        $return = [];
        if(count($items)) {
            $marketplaces = PanStocks::COUNTRY_MARKETPLACE_LIST;
            foreach ($items as $item) {
                $keys = [];
                $marketplaceIds = explode(',',$item['marketplacesIds']);
                if(count($marketplaceIds)) {
                    foreach ($marketplaceIds as $marketplaceId) {
                        $keys[] = $marketplaces[$marketplaceId];
                    }
                }
                $return[$item['ASIN']] = $keys;
            }
        }
        return $return;
    }

    public function getSKUsByStore(Store $store) {

        $qb = $this->createQueryBuilder('p')->leftJoin('p.ordersItem','oi');
        $qb->select('oi.sellerSKU')->distinct(true);
        $qb->andWhere($qb->expr()->eq('p.store',':store'))
            ->setParameter('store',$store);

        $return = [];
        foreach ($qb->getQuery()->getResult() as $item) {
            if(isset($item['sellerSKU']) && $item['sellerSKU'])
                $return[] = $item['sellerSKU'];
        }
        return $return;
    }

    public function findWrongProductsByUser(User $user) {

        $qb = $this->createQueryBuilder('p');
        $qb->select('p')
            ->leftJoin('p.ordersItem','i')
            ->leftJoin('p.store','s')
            ->leftJoin('i.order','o');
        $qb->where($qb->expr()->eq('s.user',':user'))
            ->setParameter('user',$user);
        $qb->andWhere(
            $qb->expr()->neq(
                "o.store",
                'p.store'
            )
        );
        $qb->addSelect('o.amazonOrderId');

        return $qb->getQuery()->getResult();
    }

    public function getDuplicatedProducts(Store $store = null) {

        $qb = $this->createQueryBuilder('p');
        $qb->select('p')
            ->groupBy('p.ASIN');

        if($store) {
            $qb->andWhere($qb->expr()->eq('p.store',':store'))
                ->setParameter('store',$store);
        }

        $qb->having('COUNT(p) > 1');
        return $qb->getQuery()->getResult();
    }

    public function getDuplicatedProductsInfos(Store $store = null) {

        $qb = $this->createQueryBuilder('p');
        $qb->select('p')
            ->leftJoin('p.productInfos','pi')
            ->groupBy('pi.marketplaceId');

        if($store) {
            $qb->andWhere($qb->expr()->eq('p.store',':store'))
                ->setParameter('store',$store);
        }

        $qb->having('COUNT(pi) > 1');
        return $qb->getQuery()->getResult();
    }

    public function getProductsWithWrongLargeImage(Store $store) {

        $qb = $this->createQueryBuilder('p');
        $qb->select('p')
            ->where($qb->expr()->like('p.largeImage',':largeImage'))
            ->orWhere($qb->expr()->isNull('p.largeImage'))
            ->orWhere($qb->expr()->eq('p.largeImage',':largeImageEmpty'))
        ->setParameter('largeImage','%\%%')
        ->setParameter('largeImageEmpty','');

        if($store) {
            $qb->andWhere($qb->expr()->eq('p.store',':store'))
                ->setParameter('store',$store);
        }

        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getDailyStatisticsReport(User $user = null) {

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('p');
        $qb->select('p.createdAt, DAY(p.createdAt) AS gDay, MONTH(p.createdAt) AS gDmonth, YEAR(p.createdAt) AS gDyear, COUNT(p.id) as _count');
        $qb->addGroupBy('gDay');
        $qb->addGroupBy('gDmonth');
        $qb->addGroupBy('gDyear');
        $qb->orderBy('gDyear','ASC');
        $qb->addOrderBy('gDmonth','ASC');
        $qb->addOrderBy('gDay','ASC');

        $items = $qb->getQuery()->getResult();

        $return = [];
        foreach ($items as $item) {
            $return[] = [
                'date' => $item['createdAt']->format('Y-m-d'),
                'value' => (int)$item['_count']
            ];
        }

        return $return;
    }

    public function getProductsUsersStocks() {

        $qb = $this->createQueryBuilder('p')
            ->leftJoin('p.store','s')
            ->leftJoin('s.user','u');
        $qb->select('u.email, COUNT(p) as _count')
            ->where($qb->expr()->gte('p.inStockSupplyQuantity',':inStockSupplyQuantity'))
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->setParameter('inStockSupplyQuantity',30)
            ->groupBy('u.email')
            ->orderBy('u.email', 'DESC');

        $items = $qb->getQuery()->getResult();
        $return = [];
        foreach ($items as $item) {
            $return[$item['email']] = [
                'products_count' => $item['_count']
            ];
        }
        return $return;
    }

    /**
     * @param Store $store
     * @return mixed
     */
    public function deleteProductsByStore(Store $store) {

        $qb = $this->createQueryBuilder('p');
        $qb->delete('p')
            ->andWhere($qb->expr()->eq('p.store',':store'))
            ->setParameter('store',$store);

        return $qb->getQuery()->execute();
    }

    public function getEmptyProductsToken() {

        $qb = $this->createQueryBuilder('p');
        $qb->select('p')
            ->where("p.token = ''");

        $qb->setMaxResults(1000);

        return $qb->getQuery()->getResult();
    }
}
